#define	FACE_ROOM_PTN_ITEM	'$'
#define	FACE_ROOM_PTN_MIMIC	'&'
#define	FACE_ROOM_PTN_TRAP	'^'

#if	0
typedef struct {
	long	min_lev, max_lev, sgn_lev;
	rate_t	rate;
	char	ptn[AREA_MAX_Y][AREA_MAX_X];
	sect_t	sect[AREA_MAX_Y][AREA_MAX_X];
} room_ptn_t;
#endif

static room_ptn_t	room_ptn[] = {
	{
		1, DUN_MAX_LEV, -1, 80,
		{
			"####################",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"####################",
		},
		{
			"bbbbbbbbbbbbbbbbbbbb",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"bbbbbbbbbbbbbbbbbbbb",
		}
	},
	{
		1, DUN_MAX_LEV, -1, 40,
		{
			"####################",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#................###",
			"#.................##",
			"#...............####",
			"#................###",
			"#...........#...####",
			"#...........##.#####",
			"#.........##########",
			"#.#........#########",
			"####################",
		},
		{
			"bbbbbbbbbbbbbbbbbbbb",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaabbb",
			"baaaaaaaaaaaaaaaaabb",
			"baaaaaaaaaaaaaaabbbb",
			"baaaaaaaaaaaaaaaabbb",
			"baaaaaaaaaaabaaabbbb",
			"baaaaaaaaaaabbabbbbb",
			"baaaaaaaaabbbbbbbbbb",
			"babaaaaaaaabbbbbbbbb",
			"bbbbbbbbbbbbbbbbbbbb",
		}
	},
	{
		5, DUN_MAX_LEV, -1, 80,
		{
			"####################",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#.........##########",
			"#.........##########",
			"#.........##########",
			"#.........##########",
			"#.........##########",
			"#.........##########",
			"#.........##########",
			"#.........##########",
			"#.........##########",
			"####################",
		},
		{
			"bbbbbbbbbbbbbbbbbbbb",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaabbbbbbbbbb",
			"baaaaaaaaabccccccccc",
			"baaaaaaaaabccccccccc",
			"baaaaaaaaabccccccccc",
			"baaaaaaaaabccccccccc",
			"baaaaaaaaabccccccccc",
			"baaaaaaaaabccccccccc",
			"baaaaaaaaabccccccccc",
			"baaaaaaaaabccccccccc",
			"bbbbbbbbbbbccccccccc",
		}
	},
	{
		10, DUN_MAX_LEV, -1, 80,
		{
			"####################",
			"######........######",
			"######........######",
			"######........######",
			"######........######",
			"######........######",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"######........######",
			"######........######",
			"######........######",
			"######........######",
			"######........######",
			"####################",
		},
		{
			"cccccbbbbbbbbbbccccc",
			"cccccb........bccccc",
			"cccccb........bccccc",
			"cccccb........bccccc",
			"cccccb........bccccc",
			"bbbbbb........bbbbbb",
			"b..................b",
			"b..................b",
			"b..................b",
			"b..................b",
			"b..................b",
			"b..................b",
			"b..................b",
			"b..................b",
			"bbbbbb........bbbbbb",
			"cccccb........bccccc",
			"cccccb........bccccc",
			"cccccb........bccccc",
			"cccccb........bccccc",
			"cccccbbbbbbbbbbccccc",
		}
	},
	{
		15, DUN_MAX_LEV, -1, 80,
		{
			"####################",
			"########....########",
			"######........######",
			"####............####",
			"###..............###",
			"###..............###",
			"##................##",
			"##................##",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"##................##",
			"##................##",
			"###..............###",
			"###..............###",
			"####............####",
			"######........######",
			"########....########",
			"####################",
		},
		{
			"cccccccbbbbbbccccccc",
			"cccccbbbaaaabbbccccc",
			"cccbbbaaaaaaaabbbccc",
			"ccbbaaaaaaaaaaaabbcc",
			"ccbaaaaaaaaaaaaaabcc",
			"cbbaaaaaaaaaaaaaabbc",
			"cbaaaaaaaaaaaaaaaabc",
			"bbaaaaaaaaaaaaaaaabb",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"bbaaaaaaaaaaaaaaaabb",
			"cbaaaaaaaaaaaaaaaabc",
			"cbbaaaaaaaaaaaaaabbc",
			"ccbaaaaaaaaaaaaaabcc",
			"ccbbaaaaaaaaaaaabbcc",
			"cccbbbaaaaaaaabbbccc",
			"cccccbbbaaaabbbccccc",
			"cccccccbbbbbbccccccc",
		}
	},
	{
		1, DUN_MAX_LEV, -1, 80,
		{
			"####################",
			"#........###########",
			"#........###########",
			"#........###########",
			"#........###########",
			"#........###########",
			"#........###########",
			"#........###########",
			"#........++#########",
			"#########++#########",
			"#########++#########",
			"#########++........#",
			"###########........#",
			"###########........#",
			"###########........#",
			"###########........#",
			"###########........#",
			"###########........#",
			"###########........#",
			"####################",
		},
		{
			"bbbbbbbbbbffffffffff",
			"baaaaaaaabffffffffff",
			"baaaaaaaabffffffffff",
			"baaaaaaaabffffffffff",
			"baaaaaaaabffffffffff",
			"baaaaaaaabffffffffff",
			"baaaaaaaabffffffffff",
			"baaaaaaaabffffffffff",
			"baaaaaaaaeefffffffff",
			"bbbbbbbbbeefffffffff",
			"fffffffffeeddddddddd",
			"fffffffffeeccccccccd",
			"ffffffffffdccccccccd",
			"ffffffffffdccccccccd",
			"ffffffffffdccccccccd",
			"ffffffffffdccccccccd",
			"ffffffffffdccccccccd",
			"ffffffffffdccccccccd",
			"ffffffffffdccccccccd",
			"ffffffffffdddddddddd",
		}
	},
	{
		25, DUN_MAX_LEV, -1, 80,
		{
			"####################",
			"######........######",
			"######........######",
			"######........######",
			"######........######",
			"######........######",
			"#..................#",
			"#..................#",
			"#.......#++#.......#",
			"#.......#..#.......#",
			"#.......#$.#.......#",
			"#.......####.......#",
			"#..................#",
			"#..................#",
			"######........######",
			"######........######",
			"######........######",
			"######........######",
			"######........######",
			"####################",
		},
		{
			"eeeeeddddddddddeeeee",
			"eeeeedccccccccdeeeee",
			"eeeeedccccccccdeeeee",
			"eeeeedccccccccdeeeee",
			"eeeeedccccccccdeeeee",
			"ddddddccccccccdddddd",
			"dccccccccccccccccccd",
			"dccccccccccccccccccd",
			"dcccccccbbbbcccccccd",
			"dcccccccbaabcccccccd",
			"dcccccccbaabcccccccd",
			"dcccccccbbbbcccccccd",
			"dccccccccccccccccccd",
			"dccccccccccccccccccd",
			"ddddddccccccccdddddd",
			"eeeeedccccccccdeeeee",
			"eeeeedccccccccdeeeee",
			"eeeeedccccccccdeeeee",
			"eeeeedccccccccdeeeee",
			"eeeeeddddddddddeeeee",
		}
	},
	{
		30, DUN_MAX_LEV, -1, 80,
		{
			"####################",
			"#..................#",
			"#..................#",
			"#..................#",
			"#...############...#",
			"#...+++......###...#",
			"#...+++......###...#",
			"#...+++......###...#",
			"#...#..........#...#",
			"#...#.....$....#...#",
			"#...#....$.....#...#",
			"#...#..........#...#",
			"#...###......###...#",
			"#...###......###...#",
			"#...###......###...#",
			"#...############...#",
			"#..................#",
			"#..................#",
			"#..................#",
			"####################",
		},
		{
			"eeeeeeeeeeeeeeeeeeee",
			"edddddddddddddddddde",
			"edddddddddddddddddde",
			"edddddddddddddddddde",
			"edddccbbbbbbbbccddde",
			"edddccbaaaaaabccddde",
			"edddccbaaaaaabccddde",
			"edddbbbaaaaaabbbddde",
			"edddbaaaaaaaaaabddde",
			"edddbaaaaaaaaaabddde",
			"edddbaaaaaaaaaabddde",
			"edddbaaaaaaaaaabddde",
			"edddbbbaaaaaabbbddde",
			"edddccbaaaaaabccddde",
			"edddccbaaaaaabccddde",
			"edddccbbbbbbbbccddde",
			"edddddddddddddddddde",
			"edddddddddddddddddde",
			"edddddddddddddddddde",
			"eeeeeeeeeeeeeeeeeeee",
		}
	},
	{
		35, DUN_MAX_LEV, -1, 80,
		{
			"####################",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#......^^^^^^......#",
			"#......^^^^^^......#",
			"#......^^$$^^......#",
			"#......^^$$^^......#",
			"#......^^^^^^......#",
			"#......^^^^^^......#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"####################",
		},
		{
			"bbbbbbbbbbbbbbbbbbbb",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"bbbbbbbbbbbbbbbbbbbb",
		}
	},
	{
		40, DUN_MAX_LEV, -1, 20,
		{
			"####################",
			"###..............###",
			"###..............###",
			"#..................#",
			"#..................#",
			"#..................#",
			"#.....&......&.....#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#..................#",
			"#.....&......&.....#",
			"#..................#",
			"#..................#",
			"#..................#",
			"###..............###",
			"###..............###",
			"####################",
		},
		{
			"bbbbbbbbbbbbbbbbbbbb",
			"bbbaaaaaaaaaaaaaabbb",
			"bbbaaaaaaaaaaaaaabbb",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"bbbaaaaaaaaaaaaaabbb",
			"bbbaaaaaaaaaaaaaabbb",
			"bbbbbbbbbbbbbbbbbbbb",
		}
	},
	{
		45, DUN_MAX_LEV, -1, 80,
		{
			"####################",
			"#..................#",
			"#..................#",
			"#..................#",
			"#...##.$.##...##...#",
			"#...##...##.$.##...#",
			"#..................#",
			"#..................#",
			"#..................#",
			"###...##....##...###",
			"###...##....##...###",
			"#..................#",
			"#..................#",
			"#..................#",
			"#...##.$.##...##...#",
			"#...##...##.$.##...#",
			"#..................#",
			"#..................#",
			"#..................#",
			"####################",
		},
		{
			"bbbbbbbbbbbbbbbbbbbb",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaabbaaabbaaabbaaab",
			"baaabbaaabbaaabbaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"bbbaaabbaaaabbaaabbb",
			"bbbaaabbaaaabbaaabbb",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaabbaaabbaaabbaaab",
			"baaabbaaabbaaabbaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"baaaaaaaaaaaaaaaaaab",
			"bbbbbbbbbbbbbbbbbbbb",
		}
	},
};
