/* fx.c */
void	init_fx( void );
void	inc_turn_all_fx( void );
void	natural_cure_hp_mbr( mbr_t *mbr );
void	natural_cure_mp_mbr( mbr_t *mbr );
void	sober( chr_t *p );
void	dec_turn_fx_all_mbr( long turn );
void	dec_turn_fx_all_mnstr( long turn );
abl_kind_t	get_fx_to_abl( fx_kind_t kind );
long	get_fx_to_abl_add( fx_kind_t kind );
void	exec_all_fx( mbr_t *mbr );
fx_t	*set_fx( mbr_t *mbr, fx_kind_t kind, long turn );
void	exec_fx( fx_t *p );
void	clr_fx( fx_t *fx );
void	set_fx_stat( fx_t *fx, flg_stat_t flg );
void	clr_fx_stat( fx_t *fx, flg_stat_t flg );
void	set_fx_abl( fx_t *fx );
void	clr_fx_abl( fx_t *fx );
void	set_fx_resi( fx_t *fx );
void	clr_fx_resi( fx_t *fx );
void	set_fx_pow_up_hp( fx_t *fx );
void	clr_fx_pow_up_hp( fx_t *fx );
void	clr_fx_speed( fx_t *fx );
void	exec_fx_poison( fx_t *fx );
void	quaff_potion( mbr_t *mbr, item_t *item, bool_t flg_dec );
void	quaff_potion_mnstr( mnstr_t *mnstr, item_t *item, bool_t flg_dec );
bool_t	quaff_potion_std( chr_t *p, fx_kind_t fx_k );
bool_t	quaff_potion_abl( chr_t *p, fx_kind_t fx_k );
bool_t	quaff_potion_resi( chr_t *p, fx_kind_t fx_k );
bool_t	quaff_potion_cure_lev( chr_t *p );
bool_t	quaff_potion_cure_hp_light( chr_t *p );
bool_t	quaff_potion_cure_hp_moderate( chr_t *p );
bool_t	quaff_potion_cure_hp_serious( chr_t *p );
bool_t	quaff_potion_cure_hp_max( chr_t *p );
bool_t	quaff_potion_cure_poison( chr_t *p );
bool_t	quaff_potion_cure_status( chr_t *p );
bool_t	quaff_potion_detect_mnstr( chr_t *p );
bool_t	quaff_potion_poison( chr_t *p );
bool_t	quaff_potion_pow_up_hp( chr_t *p );
bool_t	quaff_potion_speed( chr_t *p, long sgn_n );
void	fill_potion( mbr_t *mbr, item_t *potion );
bool_t	drink_liquor( chr_t *p, liquor_kind_t kind );
void	read_scroll( mbr_t *mbr, item_t *item );
bool_t	read_scroll_sleep( mbr_t *mbr );
bool_t	read_scroll_identify_item( mbr_t *mbr );
bool_t	read_scroll_detect_item( mbr_t *mbr );
bool_t	read_scroll_teleport( mbr_t *mbr );
bool_t	read_scroll_pow_up_wpn_hit( mbr_t *mbr );
bool_t	read_scroll_pow_up_wpn_wpn_crtcl( mbr_t *mbr );
bool_t	read_scroll_pow_up_wpn_dam( mbr_t *mbr );
bool_t	read_scroll_remove_curse( mbr_t *mbr );
bool_t	read_scroll_recall( void );
bool_t	zap_stick( chr_t *chr, item_t *item );
bool_t	fx_std( chr_t *p, fx_kind_t fx_k );
bool_t	set_fx_std( chr_t *p, fx_kind_t fx_k );
bool_t	fx_light( long x, long y );
bool_t	fx_darkness( long x, long y );
bool_t	fx_knock( door_t *p );
bool_t	fx_lock( door_t *p );
bool_t	fx_disarm_trap( trap_t *p, chr_t *chr );
bool_t	fx_teleport( trgt_kind_t trgt_kind, chr_t *p );
bool_t	teleport_party( void );
bool_t	teleport_mbr( mbr_t *mbr );
bool_t	recall( void );
bool_t	chk_recall( void );
bool_t	fx_create_food( chr_t *p );
bool_t	fx_detect_item( chr_t *chr );
bool_t	fx_detect_mnstr( chr_t *p );
bool_t	fx_darkvision( chr_t *p );
bool_t	fx_magic_missile(
	chr_t *o_p, trgt_kind_t trgt_kind, chr_t *d_p, rate_t rate
);
bool_t	fx_spell_attack(
	chr_t *o_p, trgt_kind_t trgt_kind, void *d_p,
	resi_kind_t resi, abl_kind_t abl, rate_t rate
);
bool_t	fx_abl( chr_t *p, fx_kind_t fx_k, long turn );
bool_t	fx_poison( chr_t *p );
bool_t	fx_pow_up_hp( chr_t *p, long turn );
void	pow_up_hp( fx_t *fx, long add_lev );
bool_t	fx_speed_up( chr_t *p1, chr_t *p2, long sgn_n, long turn );
bool_t	fx_resi( chr_t *p, fx_kind_t fx_k, long turn );
bool_t	pow_up_resi( chr_t *p, resi_kind_t resi );
bool_t	pow_down_resi( chr_t *p, resi_kind_t resi );
bool_t	pow_up_down_resi( chr_t *p, resi_kind_t resi, rate_t rate );
bool_t	fx_cure_hp_light( chr_t *p );
bool_t	fx_cure_hp_moderate( chr_t *p );
bool_t	fx_cure_hp_serious( chr_t *p );
bool_t	fx_cure_hp_max( chr_t *p );
bool_t	fx_cure_hp( chr_t *p, long cure_n );
bool_t	resurrection( mbr_t *mbr );
bool_t	fx_heal( chr_t *p );
bool_t	fx_cure_all_status( chr_t *p );
bool_t	fx_cure_status( chr_t *p, fx_kind_t fx_kind );
bool_t	fx_remove_curse( chr_t *p1, chr_t *p2 );
bool_t	remove_curse( chr_t *p1, mbr_t *mbr, rate_t difficulty );
bool_t	fx_pow_up_wpn_hit( mbr_t *mbr );
bool_t	fx_pow_up_wpn_wpn_crtcl( mbr_t *mbr );
bool_t	fx_pow_up_wpn_dam( mbr_t *mbr );
bool_t	pow_up_wpn_hit( item_t *wpn );
bool_t	pow_up_wpn_wpn_crtcl( item_t *wpn );
bool_t	pow_up_wpn_dam( item_t *wpn );
void	eat_food( mbr_t *mbr, item_t *item );
bool_t	smoke_tobacco( mbr_t *mbr, item_t *item );
void	inc_turn_smoke( mbr_t *mbr );
void	contribution( mbr_t *mbr, long gold );
void	set_stomach( chr_t *p );
void	digest( chr_t *p );
void	take_meal_mbr( mbr_t *mbr, short rate );
void	take_meal_fill_mbr( mbr_t *mbr );
bool_t	faint( mbr_t *mbr );
void	abstain( chr_t *p );
void	fraternize( chr_t *p );
bool_t	dec_infra_vision( chr_t *p );
void	catch_mbr( mnstr_t *mnstr, mbr_t *mbr );
void	release_mbr( mnstr_t *mnstr );
void	release_all_mbr( void );
abl_kind_t	get_max_abl( chr_t *p );
bool_t	roll(
	chr_t *p1, abl_kind_t abl_m1, abl_kind_t abl_s1,
	chr_t *p2, abl_kind_t abl_m2, abl_kind_t abl_s2
);
void	inc_mbr_caught( mbr_t *mbr, long n );
fx_t	*asgn_fx( fx_t *p );
void	free_fx( fx_t *p );
void	free_fx_all( fx_t *p );
void	ins_ls_fx( fx_t *ls, fx_t *p );
fx_t	*srch_fx( fx_t *ls, fx_kind_t kind );
blast_t	*get_blast( void );
